//-------------------------------------------------------------------------------------------------
// Universal KS0108 driver library
// (c) Radosaw Kwiecie, radek@dxp.pl
//-------------------------------------------------------------------------------------------------
#include "KS0108.h"
#include "font5x8.h"
//-------------------------------------------------------------------------------------------------
extern void GLCD_InitalizePorts(void);
//-------------------------------------------------------------------------------------------------
unsigned char screen_x = 0, screen_y = 0, char_Invers = 0;
//-------------------------------------------------------------------------------------------------
// GLCD_Initalize
//-------------------------------------------------------------------------------------------------
void GLCD_Initalize(void)
{
unsigned char i;
GLCD_InitalizePorts();
for(i = 0; i < 3; i++)
  GLCD_WriteCommand((DISPLAY_ON_CMD | ON), i);
}
//-------------------------------------------------------------------------------------------------
// GLCD_GoTo
//-------------------------------------------------------------------------------------------------
void GLCD_GoTo(unsigned char x, unsigned char y)
{
unsigned char i;
screen_x = x;
screen_y = y;

for(i = 0; i < KS0108_SCREEN_WIDTH/64; i++)
  {
  GLCD_WriteCommand(DISPLAY_SET_Y | 0,i);
  GLCD_WriteCommand(DISPLAY_SET_X | y,i);
  GLCD_WriteCommand(DISPLAY_START_LINE | 0,i);
  }
GLCD_WriteCommand(DISPLAY_SET_Y | (x % 64), (x / 64));
GLCD_WriteCommand(DISPLAY_SET_X | y, (x / 64));
}
//-------------------------------------------------------------------------------------------------
// GLCD_ClearScreen
//-------------------------------------------------------------------------------------------------
void GLCD_ClearScreen(void)
{
unsigned char i, j;
for(j = 0; j < KS0108_SCREEN_HEIGHT/8; j++)
  {
  GLCD_GoTo(0,j);
  for(i = 0; i < KS0108_SCREEN_WIDTH; i++)
    GLCD_WriteData(0x00);
  }
}
/*
//-------------------------------------------------------------------------------------------------
// GLCD_WriteCharInvers
//-------------------------------------------------------------------------------------------------
void GLCD_WriteCharInvers(char charToWrite)
{
int i;
charToWrite -= 32; 
for(i = 0; i < 5; i++) 
	{
	char_Invers = ~GLCD_ReadByteFromROMMemory((char *)((int)font5x8 + (5 * charToWrite) + i));
   	GLCD_WriteData(char_Invers); 
   	}
GLCD_WriteData(0x00);
}
//-------------------------------------------------------------------------------------------------
// GLCD_WriteStringInvers
//-------------------------------------------------------------------------------------------------
void GLCD_WriteStringInvers(char * stringToWrite)
{
while(*stringToWrite)
  GLCD_WriteCharInvers(*stringToWrite++);
}
*/
//-------------------------------------------------------------------------------------------------
// GLCD_WriteChar
//-------------------------------------------------------------------------------------------------
void GLCD_WriteChar(char charToWrite)
{
int i;
charToWrite -= 32; 
for(i = 0; i < 5; i++) 
   GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)((int)font5x8 + (5 * charToWrite) + i))); 
GLCD_WriteData(0x00);
}
//-------------------------------------------------------------------------------------------------
// GLCD_WriteString
//-------------------------------------------------------------------------------------------------
void GLCD_WriteString(char * stringToWrite)
{
while(*stringToWrite)
  GLCD_WriteChar(*stringToWrite++);
}
//-------------------------------------------------------------------------------------------------
// GLCD_SetPixel
//-------------------------------------------------------------------------------------------------
void GLCD_SetPixel(unsigned char x, unsigned char y, unsigned char color)
{
unsigned char tmp;
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();		// read 2 times
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();		// read always one byte
GLCD_GoTo(x, (y / 8));		// position of byte
tmp |= (1 << (y % 8));		// select only one bit
GLCD_WriteData(tmp);		// write bit
}
//-------------------------------------------------------------------------------------------------
// GLCD_TogglePixel
//-------------------------------------------------------------------------------------------------
void GLCD_TogglePixel(unsigned char x, unsigned char y, unsigned char color)
{
unsigned char tmp;
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();		// read 2 times
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();		// read always one byte
GLCD_GoTo(x, (y / 8));		// position of byte
tmp ^= (1 << (y % 8));		// toggle only one bit
GLCD_WriteData(tmp);		// write bit
}
//-------------------------------------------------------------------------------------------------
// GLCD_Bitmap
//-------------------------------------------------------------------------------------------------
void GLCD_Bitmap(char * bmp, unsigned char x, unsigned char y, unsigned char dx, unsigned char dy)
{
unsigned char i, j;
for(j = 0; j < dy / 8; j++)
  {
  GLCD_GoTo(x,y + j);
  for(i = 0; i < dx; i++) 
    GLCD_WriteData(GLCD_ReadByteFromROMMemory(bmp++));
  }
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------





